/*
 * Copyright (C) 2004 ruby-ecore team (see AUTHORS)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __RB_EVENT_HANDLER_H
#define __RB_EVENT_HANDLER_H

#define ADD_EVENT(mod, constname, clsname, obj) \
	rb_remove_method (rb_singleton_class (cEcoreEvent), "inherited"); \
\
	(obj) = rb_define_class_under ((mod), (clsname), cEcoreEvent); \
	rb_define_private_method (rb_singleton_class ((obj)), \
	                          "new", NULL, 0); \
\
	rb_define_const ((obj), "TYPE", INT2FIX (constname)); \
	rb_hash_aset (event_classes, INT2FIX (constname), (obj)); \
	rb_define_singleton_method (cEcoreEvent, "inherited", c_ev_inherited, 1);

void Init_EventHandler (void);

VALUE c_ev_inherited (VALUE klass, VALUE child);

#ifndef __RB_EVENT_HANDLER_C
extern VALUE event_classes, cEcoreEvent;
#endif

#endif
